#ifndef EP_LIB_INTERCOMM_HPP_INCLUDED
#define EP_LIB_INTERCOMM_HPP_INCLUDED

namespace ep_lib
{

  typedef void* MPI_Datatype;
  typedef void* MPI_Op;

  int MPI_Send_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
  int MPI_Ssend_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);

  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);


  int MPI_Comm_dup_intercomm(MPI_Comm comm, MPI_Comm *newcomm);

  int MPI_Comm_free_intercomm(MPI_Comm* comm);

  int MPI_Barrier_intercomm(MPI_Comm comm);

  int Message_Check_intercomm(MPI_Comm comm);

  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);


  int MPI_Iprobe_intercomm(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
  int MPI_Improbe_intercomm(int source, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);




}


#endif // EP_LIB_INTERCOMM_HPP_INCLUDED
